#include<stdio.h>
#include<string.h>
#define Max 30000

FILE *infile;
char line[1000];
char *charP;
char eof;

void getaline(){
  int intch;
  char lastch;
  charP = line;
  lastch = 0;
  intch = fgetc(infile);
  while (intch!=10 && intch!=EOF) {
    if (intch!=EOF) {
      if (intch=='\t')  intch = ' ';
      if (intch!=' ' || lastch!=' ')  *charP++ = intch;
      lastch = intch;
      intch = fgetc(infile);
    }
  }
  if (lastch==' ')  charP--;
  *charP = 0;
  eof = intch==EOF && charP==line;
  charP = line;
}

char getach() {
  char ch;
  ch = *charP;
  if (*charP)  charP++;
  return  ch;
}

int main(int argc, char **argv) {
  char debug = 0;
  FILE *tempfile;
  FILE *outfile;
  int linenumber = 0;
  int bytecount;
  int intch;
  int sum;
  char hassymbol;
  int i, j;
  int errors = 0;
  char *charP;
  char prefix[] = "AA";
  char symbols[30000];
  char *symbolP;
  char *labels[Max];
  int defined[Max];
  char labelA[Max];
  char labelB[Max];
  char symbolA[Max];
  char symbolB[Max];
  int symbollabel[Max];
  int label;
  char *labelP;
  char *opcodeP;
  char *lastP;
  char opcode[1000];
  char mesg[1000];
  char *mesgP;
  char ch;
  char *opcodes[] = {
    "B", "IF BLOCKED GOTO",
    "M", "IF MARKED GOTO",
    "Z", "IF ZERO GOTO",
    "b", "IF NOT BLOCKED GOTO",
    "m", "IF NOT MARKED GOTO",
    "z", "IF NOT ZERO GOTO",
    "S", "GOSUB",
    "T", "GOTO",
    "D", "PUT DOWN",
    "E", "END",
    "L", "LEFT",
    "N", "RETURN",
    "P", "STOP",
    "R", "RIGHT",
    "U", "PICK UP",
    "W", "WALK",
    "","\\"
  };
  for (i=0; i<Max; i++) {
    defined[i] = 0;
    labelA[i] = ' ';
    labelB[i] = ' ';
    symbolA[i] = ' ';
    symbolB[i] = ' ';
  }
  if (argc!=3) {
    printf("wrong argument count");
    return 1;
  }
  infile = fopen(argv[1], "r");
  tempfile = fopen("temp.txt", "w");
  outfile = fopen(argv[2], "w");
  label = 0;
  labelP = symbols;
  symbols[0] = 0;
  labels[0] = NULL;
  eof = 0;
  while (!eof) {
    while (1) {
      getaline();
      ch = getach();
      if (eof)  break;
      if (debug)  fputc('!', tempfile);
      if (debug)  fputc(10, tempfile);
      linenumber++;
      symbolP = labelP;
      if (!ch || ch=='*') {
        fputc(' ', tempfile);
        fputc(' ', tempfile);
        fputc(' ', tempfile);
        fputc(' ', tempfile);
        fputc(' ', tempfile);
        break;
      }
      else if (ch==' ') {
        fputc(' ', tempfile);
        fputc(' ', tempfile);
      }
      else {
        do {
          *symbolP++ = ch;
          ch = getach();
        }
        while (ch && ch!=' ');
        *symbolP++ = 0;
        for (i=0; i<label; i++)
          if (!strcmp(labels[i], labelP)) break;
        if (i<label) {
          if (defined[i]) {
            printf("%d redefined label - %s - first defined in line %d\n",
                 linenumber, labels[i], defined[i]);
            errors++;
          }
          else {
            for (charP=labels[i]; *charP++; );
            labelA[linenumber] = *charP;
            fputc(*charP++, tempfile);
            labelB[linenumber] = *charP;
            fputc(*charP, tempfile);
          }
        }
        else {
          defined[label] = linenumber;
          labels[label++] = labelP;
          labelA[linenumber] = prefix[0];
          labelB[linenumber] = prefix[1];
          *symbolP++ = prefix[0];
          *symbolP++ = prefix[1];
          labelP = symbolP;
          fputc(prefix[0], tempfile);
          fputc(prefix[1]++, tempfile);
          if (prefix[1]>'Z') {
            prefix[1] = 'A';
            prefix[0]++;
          }
        }
        if (!ch) {
          fputc(' ', tempfile);
          fputc(' ', tempfile);
          fputc(' ', tempfile);
          break;
        }
      }
      ch = getach();
      lastP = opcode;
      mesgP = mesg;
      opcodeP = opcode;
      symbolP = labelP;
      while (ch) {
        if (ch==' ') {
          symbolP = labelP;
          lastP = opcodeP;
        }
        else  *symbolP++ = ch;
        *mesgP++ = ch;
        *opcodeP++ = ch;
        ch = getach();
      }
      *opcodeP = 0;
      *mesgP = 0;
      *opcodeP = 0;
      hassymbol = 0;
      for (j=1; strcmp(opcodes[j], "\\"); j=j+2) {
        if (!strcmp(opcodes[j], opcode)) break;
      }
      if (!strcmp(opcodes[j], "\\")) {
        hassymbol = 1;
        *lastP = 0;
        for (j=1; strcmp(opcodes[j], "\\"); j=j+2) {
          if (!strcmp(opcodes[j], opcode)) break;
        }
      }
      if (!strcmp(opcodes[j], "\\")) {
        errors++;
        printf("%d bad command - %s\n", linenumber, mesg);
        fputc('Q', tempfile);
        fputc(' ', tempfile);
        fputc(' ', tempfile);
        break;
      }
      else  fputc(*opcodes[j-1], tempfile);
      if (j<16) {
        if (!hassymbol) {
          errors++;
          *mesgP = 0;
          printf("%d missing label - %s\n", linenumber, mesg);
          fputc(' ', outfile);
          fputc(' ', outfile);
        }
        else {
          *symbolP++ = 0;
          for (i=0; i<label; i++)
            if (!strcmp(labels[i], labelP)) break;
          if (i<label) {
            symbollabel[linenumber] = i;
            for (charP=labels[i]; *charP++; );
            symbolA[linenumber] = *charP;
            fputc(*charP++, tempfile);
            symbolB[linenumber] = *charP;
            fputc(*charP, tempfile);
          }
          else {
            labels[label++] = labelP;
            symbollabel[linenumber] = label-1;
            *symbolP++ = prefix[0];
            *symbolP++ = prefix[1];
            labelP = symbolP;
            symbolA[linenumber] = prefix[0];
            symbolB[linenumber] = prefix[1];
            fputc(prefix[0], tempfile);
            fputc(prefix[1]++, tempfile);
            if (prefix[1]>'Z') {
              prefix[1] = 'A';
              prefix[0]++;
            }
          }
        }
      }
      else {
        if (hassymbol) {
          errors++;
          printf("%d extra label - %s\n", linenumber, lastP+1);
        }
        fputc(' ', tempfile);
        fputc(' ', tempfile);
      }
    }
  }

//  printf("%d\n", linenumber);
  for (i=1; i<=linenumber; i++) {
//    printf("%d %c %c\n", i, symbolA[i], symbolB[i]);
    if (symbolA[i]!=' ' || symbolB[i]!=' ') {
      for (j=1; j<=linenumber; j++) {
//        printf("%d %d %c %c %c %c\n",
//            i, j, labelA[j], symbolA[i], labelB[j], symbolB[i]);
        if (labelA[j]==symbolA[i] && labelB[j]==symbolB[i])  break;
      }
//      printf("%d %d\n", j, linenumber);
      if (j>linenumber) {
        printf("%d undefined label - %s\n", i, labels[symbollabel[i]]);
        errors++;
      }
    }
  }


  if (!errors)  printf("[no errors]\n");

  linenumber++;

  fputc(' ', tempfile);
  fputc(' ', tempfile);
  fputc('E', tempfile);
  fputc(' ', tempfile);
  fputc(' ', tempfile);

  linenumber++;

  fputc(0, tempfile);
  fputc(0, tempfile);
  fputc(0, tempfile);
  fputc(0, tempfile);
  fputc(0, tempfile);

  if (debug) {
    fputc(10, tempfile);
    for (charP=symbols; charP<labelP; charP++) {
      if (*charP==0 && debug)
        fputc(10, tempfile);
      else fputc(*charP, tempfile);
    }
  }
  else {
    fputc(0, outfile);
    fputc(0, outfile);
    fputc(3, outfile);
    fputc(0xff, outfile);
    fputc(0xa1, outfile);
    fputc(0x24, outfile);
    fputc(0x25, outfile);
    fputc(0x26, outfile);

    sum = 5*(linenumber);
    fputc(0, outfile);
    fputc(sum/256, outfile);
    fputc(sum-(sum/256)*256, outfile);
    fputc(0x20, outfile);
    fputc(0, outfile);

//    printf("%d\n", sum);
    bytecount = 0;

    fclose(tempfile);
    tempfile = fopen("temp.txt", "r");
    intch = fgetc(tempfile);
    while (intch!=EOF) {
      bytecount++;
      fputc (intch, outfile);
      intch = fgetc(tempfile);
    }

//    printf("%d\n", bytecount);
/*
    fputc(0, outfile);
    fputc(0, outfile);
    fputc(1, outfile);
    fputc(0xff, outfile);
    fputc(0xa1, outfile);
    fputc(0x27, outfile);

    sum = labelP-symbols+1;
    fputc(0, outfile);
    fputc(sum/256, outfile);
    fputc(sum-(sum/256)*256, outfile);
    fputc(0x20, outfile);
    fputc(0, outfile);
  }

  for (charP=symbols; charP<labelP; charP++) {
    if (*charP==0 && debug)
      fputc(10, outfile);
    else fputc(*charP, outfile);
  }

  if (!debug) {

    fputc(0, outfile);

*/
    fputc(0, outfile);
    fputc(0, outfile);
    fputc(3, outfile);
    fputc(0xff, outfile);
    fputc(0xa1, outfile);
    fputc(0x39, outfile);
    fputc(0x3a, outfile);
    fputc(0x3b, outfile);

    fputc(0xff, outfile);
    fputc(0, outfile);
    fputc(0, outfile);
    fputc(0x20, outfile);
    fputc(0, outfile);

  }

  fclose(infile);
  fclose(tempfile);
  fclose(outfile);
  return 0;
}
